#ifndef CONSOLE_H_INCLUDED
#define CONSOLE_H_INCLUDED

#include "typedef.h"
#include "vsurface.h"

#define	FSIZE		(6)	// ptHg̕

// F`
#define	FC_BLACK	0x00000000
#define	FC_DBLUE	(0x8f8f8f8f &  BMASK32)
#define	FC_DGREEN	(0x8f8f8f8f &  GMASK32)
#define	FC_DCYAN	(0x8f8f8f8f & (GMASK32|BMASK32))
#define	FC_DRED		(0x8f8f8f8f &  RMASK32)
#define	FC_DMAGENTA	(0x8f8f8f8f & (RMASK32|BMASK32))
#define	FC_DYELLOW	(0x8f8f8f8f & (RMASK32|GMASK32))
#define	FC_GRAY		(0x8f8f8f8f & (RMASK32|GMASK32|BMASK32))
#define	FC_BLUE		(0xffffffff &  BMASK32)
#define	FC_GREEN	(0xffffffff &  GMASK32)
#define	FC_CYAN		(0xffffffff & (GMASK32|BMASK32))
#define	FC_RED		(0xffffffff &  RMASK32)
#define	FC_MAGENTA	(0xffffffff & (RMASK32|BMASK32))
#define	FC_YELLOW	(0xffffffff & (RMASK32|GMASK32))
#define	FC_WHITE	(0xffffffff & (RMASK32|GMASK32|BMASK32))


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class JFont {
protected:
	static VSurface *ZFont;		// SptHgf[^T[tFXւ̃|C^
	static VSurface *HFont;		// ptHgf[^T[tFXւ̃|C^
	
	static int zWidth, zHeight;	// Sp̕,
	static int hWidth, hHeight;	// p̕,
	
public:
	JFont();									// RXgN^
	~JFont();									// fXgN^
	
	static bool OpenFont( char *, char * );		// t@Ct@CJ
	static void CloseFont();					// tHgj
	
	static int FontWidth(){ return hWidth; }	// tHg̕擾(p)
	static int FontHeight(){ return hHeight; }	// tHg̍擾
	
	void PutCharh( VSurface *, int, int, BYTE, DWORD, DWORD );	// p`
	void PutCharz( VSurface *, int, int, WORD, DWORD, DWORD );	// Sp`

};


class ZCons : public JFont, public VSurface {
protected:
	VRect con;					// `͈
	int Xmax,Ymax;				// cő啶(p)
	int x,y;					// J[\ʒu
	DWORD fgc,bgc;				// `FƔwiF
	char Caption[129];			// LvV
	
	void DrawFrame();							// g`
	void ScrollUp();							// XN[Abv
	
public:
	ZCons();									// RXgN^
	virtual ~ZCons();							// fXgN^
	
	bool Init   ( int, int, const char *, DWORD = FC_WHITE, DWORD = FC_BLACK );	// (ŃTCYw)
	bool InitRes( int, int, const char *, DWORD = FC_WHITE, DWORD = FC_BLACK );	// (𑜓xŃTCYw)
	
	void Locate( int, int );					// J[\ʒuݒ
	void LocateR( int, int );					// J[\ʒuݒ(΍W)
	void SetColor( DWORD, DWORD );				// `Fݒ
	void SetColor( DWORD );
	void Cls();									// ʏ
	
	void PutCharH( BYTE );						// p1`
	void PutCharZ( WORD );						// Sp1`
	
	void Print( const char *, ... );			// t`(䕶Ή)
	void Printf( const char *, ... );			// t`(䕶Ή)
	void Printfr( const char *, ... );			// t`(El)
	
	int GetXline();								// ő啶擾
	int GetYline();								// cő啶擾
};


#endif	// CONSOLE_H_INCLUDED
