// ---------------------------------------------------------------------------
//	Device֘ANX
//	  Original     : cisc
//	  Modification : Yumitaro
// ---------------------------------------------------------------------------
#include <string.h>
#include <new>

#include "device.h"


////////////////////////////////////////////////////////////////
// DeviceList
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
DeviceList::DeviceList( void ) : node(NULL) {}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
DeviceList::~DeviceList( void )
{
	Cleanup();
}


////////////////////////////////////////////////////////////////
// m[h
////////////////////////////////////////////////////////////////
DeviceList::Node *DeviceList::FindNode( const ID id )
{
	for( Node *n = node; n; n = n->next ){
		if( n->entry->GetID() == id )
			return n;
	}
	return NULL;
}


////////////////////////////////////////////////////////////////
// foCXXgS
////////////////////////////////////////////////////////////////
void DeviceList::Cleanup( void )
{
	Node *n = node;
	while( n ){
		Node *nx = n->next;
		delete n;
		n = nx;
	}
	node = NULL;
}


////////////////////////////////////////////////////////////////
// foCXǉ
////////////////////////////////////////////////////////////////
bool DeviceList::Add( IDevice *t )
{
	ID id = t->GetID();
	if( !id ) return false;
	
	Node *n = FindNode( id );
	if( n ){
		n->count++;
		return true;
	}else{
		n = new Node;
		if( !n ) return false;
		n->entry = t;
		n->next  = node;
		n->count = 1;
		node = n;
		return true;
	}
}


////////////////////////////////////////////////////////////////
// foCX폜(|C^)
////////////////////////////////////////////////////////////////
bool DeviceList::Del( IDevice *t )
{
	return t->GetID() ? Del( t->GetID() ) : false;
}


////////////////////////////////////////////////////////////////
// foCX폜(ID)
////////////////////////////////////////////////////////////////
bool DeviceList::Del( const ID id )
{
	for( Node **r = &node; *r; r = &((*r)->next) ){
		if( ((*r)->entry->GetID() == id) && ((*r)->count) ){
			((*r)->count)--;
//		if( (*r)->entry->GetID() == id ){
//			Node* d = *r;
//			if( !--d->count ){
//				*r = d->next;
//				delete d;
//			}
			return true;
		}
	}
	return false;
}


////////////////////////////////////////////////////////////////
// foCX
////////////////////////////////////////////////////////////////
IDevice *DeviceList::Find( const ID id )
{
	Node *n = FindNode( id );
	return n ? n->entry : NULL;
}
