#ifndef MEMORY_H_INCLUDED
#define MEMORY_H_INCLUDED

#include "typedef.h"
#include "device.h"
#include "ini.h"


// ubN
#define MAXRMB	(22)
#define MAXWMB	(16)

////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
// ubNNX
class MemBlock {
protected:
	char Name[33];				// ubN
	BYTE *MB;					// ubNւ̃|C^
	int RWait;					// ANZXEFCg(Ǎ)
	int WWait;					// ANZXEFCg()
	bool WPt;					// CgveNgtO
	
public:
	MemBlock();									// RXgN^
	~MemBlock();								// fXgN^
	
	void SetMemory( const char *, BYTE *, int, int, bool );	// ubNݒ
	void SetWait( int, int );					// ANZXEFCgݒ
	int GetWait();								// ANZXEFCg擾
	void SetProtect( bool );					// CgveNgݒ
	bool GetProtect();							// CgveNg擾
	
	const char *GetName();						// ubN擾
	
	BYTE Read( WORD, int * = NULL );			// [h
	void Write( WORD, BYTE, int * = NULL );		// Cg
};


class MEM6 : public Device, public IDoko {
protected:
	// ROM\
	typedef struct{
		const char *FileName;	// t@C
		DWORD Crc;				// CRC32
	} ROMINFO;
	
	// \
	typedef struct{
		const ROMINFO *Rinf;	// ROMւ̃|C^
		const int Rnum;			// ROM̗vf
		DWORD Size;				// TCY
		BYTE Init;				// f[^
		int WaitR;				// ANZXEFCg(Read)
		int WaitW;				// ANZXEFCg(Write)
	} MEMINFO;
	
	// ROMe[u\
	struct ROMINFOTABLE {
		const ROMINFO *System1;
		const ROMINFO *System2;
		const ROMINFO *CGRom1;
		const ROMINFO *CGRom2;
		const ROMINFO *Kanji;
		const ROMINFO *Voice;
		
		ROMINFOTABLE() : System1(NULL), System2(NULL), CGRom1(NULL), CGRom2(NULL),
						 Kanji(NULL), Voice(NULL) {}
	};
	
	// e[u\
	struct MEMINFOTABLE {
		const MEMINFO *EmptRom;
		const MEMINFO *EmptRam;
		const MEMINFO *ExtRom;
		const MEMINFO *IntRam;
		const MEMINFO *ExtRam;
		const MEMINFO *SolRam;
		
		const MEMINFO *System1;
		const MEMINFO *System2;
		const MEMINFO *CGRom1;
		const MEMINFO *CGRom2;
		const MEMINFO *Kanji;
		const MEMINFO *Voice;
		
		MEMINFOTABLE() : EmptRom(NULL), EmptRam(NULL), ExtRom(NULL), IntRam(NULL), ExtRam(NULL),
						 SolRam(NULL), System1(NULL), System2(NULL), CGRom1(NULL), CGRom2(NULL),
						 Kanji(NULL), Voice(NULL) {}
	};
	
	// 
	static const MEMINFO IEMPTROM;
	static const MEMINFO IEMPTRAM;
	static const MEMINFO IEXTROM;
	static const MEMINFO IEXTRAM;
	
	ROMINFOTABLE RomTable;		// ROMe[u
	MEMINFOTABLE MemTable;		// e[u
	
	bool CGBank;				// CG ROM BANK true:L false:
	bool UseExtRom;				// gROM     true:L false:
	bool UseExtRam;				// gRAM     true:L false:
	
	BYTE *MainRom;				// BASIC ROM	60,61:16KB 62,66:32KB
	BYTE *ExtRom;				// g ROM		60,61:16KB 62,66:16KB
	BYTE *CGRom1;				// CG ROM1		60,61: 4KB 62,66: 8KB
	BYTE *CGRom2;				// CG ROM2		60,61: -KB 62,66: 8KB
	BYTE *KanjiRom;				//  ROM		60,61: -KB 62,66:32KB
	BYTE *VoiceRom;				//  ROM	60,61: -KB 62,66:16KB
	
	BYTE *IntRam;				//  RAM		60,61:16KB 62,66:64KB
	BYTE *ExtRam;				// O RAM		60,61:16KB 62,66:64KB
	BYTE *EmptyRom;				// ROM	60,61: 8KB 62,66: 8KB
	BYTE *EmptyRam;				// RAM	60,61: 8KB 62,66: 8KB
	
	MemBlock RomB[MAXRMB];		// ROMubN
	MemBlock RamB[MAXWMB];		// RAMubN
	
	MemBlock *Rm_blk[8];		// [hubN|C^(8KB*8)
	MemBlock *Wm_blk[8];		// CgubN|C^(8KB*8)
	
	char FilePath[PATH_MAX];	// gROMt@CtpX
	int M1Wait;					// M1EFCg
	bool EnableChkCRC;			// CRC`FbN  true:L false:
	
	
	bool AllocMemory( BYTE **, const MEMINFO *, const char * );	// mۂROMt@CǍ
	virtual void SetRamValue() = 0;			// RAM̏lݒ
	virtual bool InitSpecific() = 0;		// @ʏ
	
	// m̃J[gbW ------------------------------------------
	static const MEMINFO ISOLRAM;	// 
	bool UseSol;					// true:L false:
	int SolBank;					// ROMoN(0-15)
	void SetSolBank( BYTE );		// ROMoNݒ
	// -------------------------------------------------------------
	
public:
	MEM6( VM6 *, const ID& );				// RXgN^
	virtual ~MEM6();						// fXgN^
	
	bool AllocAllMemory( const char *, bool );	// SmۂROMt@CǍ
	bool Init( bool, bool );				// 
	virtual void Patch();					// pb`
	virtual void Reset();					// Zbg
	
	BYTE Fetch( WORD, int * = NULL );		// tFb`(M1)
	BYTE Read( WORD, int * = NULL );		// [h
	void Write( WORD, BYTE, int * = NULL );	// Cg
	
	bool MountExtRom( const char * );		// gROM }Eg
	void UnmountExtRom();					// gROM A}Eg
	const char *GetFile();					// gROMt@CpX擾
	
	// 8255o͊֘A֐
	virtual void SetCGBank( bool );			// CG ROM BANK ؂ւ
	
	// ڃANZX֐
	virtual BYTE ReadMainRom( WORD );
	virtual BYTE ReadMainRam( WORD );
	virtual BYTE ReadExtRom ( WORD );
	virtual BYTE ReadCGrom1 ( WORD );
	virtual BYTE ReadCGrom2 ( WORD );
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	virtual const char *GetReadMemBlk( int );
	virtual const char *GetWriteMemBlk( int );
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// I/OANZX֐
	void Out7FH( int, BYTE );
	
	// foCXID
	enum IDOut{ out7FH=0 };
	enum IDIn {};
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class MEM60 : public MEM6 {
private:
	// ROM
	static const ROMINFO AMAINROM[];
	static const ROMINFO ACGROM1[];
	
	// 
	static const MEMINFO IMAINROM;
	static const MEMINFO ICGROM0;
	static const MEMINFO ICGROM1;
	static const MEMINFO IINTRAM;
	
	void SetRamValue();						// RAM̏lݒ
	bool InitSpecific();					// @ʏ
	
	void SetMemBlock();						// ubNݒ(60̂)
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
public:
	MEM60( VM6 *, const ID& );				// RXgN^
	~MEM60();								// fXgN^
	
	void Reset();							// Zbg
	
	// ڃANZX֐
	BYTE ReadMainRam( WORD );
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class MEM61 : public MEM60 {
private:
	// ROM
	static const ROMINFO AMAINROM[];
	static const ROMINFO ACGROM1[];
	
	// 
	static const MEMINFO IMAINROM;
	static const MEMINFO ICGROM0;
	static const MEMINFO ICGROM1;
	static const MEMINFO IINTRAM;
	
public:
	MEM61( VM6 *, const ID& );				// RXgN^
	~MEM61();								// fXgN^
};


class MEM62 : public MEM6 {
protected:
	// ROM
	static const ROMINFO AMAINROM[];
	static const ROMINFO ACGROM1[];
	static const ROMINFO ACGROM2[];
	static const ROMINFO AKANJI[];
	static const ROMINFO AVOICE[];
	
	// 
	static const MEMINFO IMAINROM;
	static const MEMINFO ICGROM1;
	static const MEMINFO ICGROM2;
	static const MEMINFO IKANJI;
	static const MEMINFO IVOICE;
	static const MEMINFO IINTRAM;
	
	bool cgrom;			// CG ROM Ip true:N60[h false:N60m[h
	bool kj_rom;		// ROM,ROM Ip true:ROM false:ROM
	bool kj_LR;			// ROM EIp true:E false:
	
	bool cgenable;		// CG ROMANZXtO true:ANZX false:ANZXs
	BYTE cgaddr;		// CG ROMAhX A13,14,15
	
	BYTE Rf0;			// Rg[WX^
	BYTE Rf1;			// Rg[WX^
	BYTE Rf2;			// Rg[WX^
	
	void SetRamValue();						// RAM̏lݒ
	bool InitSpecific();					// @ʏ
	
	void SetMemBlockR( BYTE, BYTE );		// [h̃ubNw(62,66̂)
	void SetMemBlockW( BYTE );				// Cg̃ubNw(62,66̂)
	void SetWait( BYTE );					// ANZXEFCgݒ
	BYTE GetWait();							// ANZXEFCg擾
	
	void SetCGrom( BYTE );					// CG ROM AhXݒ(62,66̂)
	void SelectCGrom( int );				// CG ROM I(62,66̂)
	void SelectKanjiRom( BYTE );			// ROM  ROM ؂ւ(62,66̂)
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void OutC1H( int, BYTE );
	void OutC2H( int, BYTE );
	void OutC3H( int, BYTE );
	void OutF0H( int, BYTE );
	void OutF1H( int, BYTE );
	void OutF2H( int, BYTE );
	void OutF3H( int, BYTE );
	void OutF8H( int, BYTE );
	
	BYTE InF0H( int );
	BYTE InF1H( int );
	BYTE InF2H( int );
	BYTE InF3H( int );
	
public:
	MEM62( VM6 *, const ID& );				// RXgN^
	virtual ~MEM62();						// fXgN^
	
	void Reset();							// Zbg
	
	// 8255o͊֘A֐
	void SetCGBank( bool );					// CG ROM BANK ؂ւ
	
	// ڃANZX֐
	BYTE ReadMainRom( WORD );
	BYTE ReadMainRam( WORD );
	BYTE ReadCGrom2( WORD );
	BYTE ReadKanjiRom( WORD );
	BYTE ReadVoiceRom( WORD );
	
	// foCXID
	enum IDOut{ out7FH=0, outC1H, outC2H, outC3H, outF0H,  outF1H, outF2H, outF3H, outF8H };
	enum IDIn {                                    inF0H=0, inF1H,  inF2H,  inF3H         };
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class MEM66 : public MEM62 {
private:
	// ROM
	static const ROMINFO AMAINROM[];
	static const ROMINFO ACGROM1[];
	static const ROMINFO ACGROM2[];
	static const ROMINFO AKANJI[];
	static const ROMINFO AVOICE[];
	
	// 
	static const MEMINFO IMAINROM;
	static const MEMINFO ICGROM1;
	static const MEMINFO ICGROM2;
	static const MEMINFO IKANJI;
	static const MEMINFO IVOICE;
	static const MEMINFO IINTRAM;
	
	void SelectKanjiRom( BYTE );			// ROM  ROM ؂ւ(62,66̂)
	
public:
	MEM66( VM6 *, const ID& );				// RXgN^
	~MEM66();								// fXgN^
};


#endif	// MEMORY_H_INCLUDED
