#include <new>

#include "pc6001v.h"
#include "id_menu.h"

#include "breakpoint.h"
#include "common.h"
#include "config.h"
#include "cpum.h"
#include "cpus.h"
#include "debug.h"
#include "disk.h"
#include "error.h"
#include "graph.h"
#include "intr.h"
#include "joystick.h"
#include "keyboard.h"
#include "memory.h"
#include "osd.h"
#include "pio.h"
#include "psg.h"
#include "schedule.h"
#include "sound.h"
#include "status.h"
#include "tape.h"
#include "vdg.h"
#include "voice.h"
#include "vsurface.h"

#include "p6el.h"


#define	FRAMERATE	(VSYNC_HZ/(cfg->GetFrameSkip()+1))



////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
EL6::EL6( void ) : vm(NULL), cfg(NULL), sche(NULL), graph(NULL), snd(NULL), joy(NULL), staw(NULL),
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	regw(NULL), memw(NULL), monw(NULL),
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	UpDateFPSID(NULL), UDFPSCount(0), FSkipCount(0)
{}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
EL6::~EL6( void )
{
	DeleteAllObject();
}



////////////////////////////////////////////////////////////////
// Xbh֐(I[o[Ch)
////////////////////////////////////////////////////////////////
void EL6::OnThread( void *inst )
{
	EL6 *p6;
	
	p6 = STATIC_CAST( EL6 *, inst );	// g̃IuWFNg|C^擾
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( p6->cfg->GetMonDisp() ){
	// j^[h
		while( !this->cThread::IsCancel() ){
			// ʍXV
			if( p6->sche->IsScreenUpdate() ) p6->ScreenUpdate();
			p6->Wait();		// EFCg
		}
	}else
	// ʏ탂[h
		if( p6->vm->BpExistBreakPoint() ){
			// u[N|Cg
			while( !this->cThread::IsCancel() ){
				// |[YȂ牽Ȃ
				if( p6->sche->GetPauseEnable() )
					// EFCg
					p6->Wait();
				else{
					p6->Emu();		// 1ߎs
					
					if( p6->vm->evsc->IsVSYNC() ){
						p6->vm->key->ScanMatrix();	// L[}gNXXL
						
						// TEhXV
						p6->SoundUpdate( 0 );
						// ʍXV
						if( p6->sche->IsScreenUpdate() ) p6->ScreenUpdate();
						
						// L[
						if( IsAutoKey() ){
							BYTE key = GetAutoKey();
							if( key ) p6->vm->cpus->ReqKeyIntr( 0, key );
						}
						
						// EFCg
						p6->Wait();
					}
				}
				
				// u[N|Cg`FbN
				if( p6->vm->BpCheckBreakPoint( BPoint::BP_PC, p6->vm->cpum->GetPC(), 0, NULL ) || p6->vm->BpIsReqBreak() ){
					this->cThread::Cancel();	// XbhItOĂ
					p6->vm->BpResetBreak();
					OSD_PushEvent( EV_DEBUGMODEBP, p6->vm->cpum->GetPC() );
				}
			}
		}else
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	{	// ʏs
		while( !this->cThread::IsCancel() ){
			// |[YȂʍXV̂
			if( p6->sche->GetPauseEnable() ){
				// ʍXV}ĂʍXV
				// m[EFCg̎FPSςȂ悤ɂ
				if( p6->sche->IsScreenUpdate() ) p6->ScreenUpdate();
			}else{
				// L[}gNXXL
				bool matchg = p6->vm->key->ScanMatrix();
				
				// vCL^
				if( REPLAY::GetStatus() == REP_RECORD )
					REPLAY::ReplayWriteFrame( p6->vm->key->GetMatrix2(), matchg );
				
				// vCĐ
				if( REPLAY::GetStatus() == REP_REPLAY ){
					REPLAY::ReplayReadFrame( p6->vm->key->GetMatrix() );
				}
				
				p6->EmuVSYNC();			// 1ʕs
				
				// rfILv`?
				if( AVI6::IsAVI() ){
					// rfILv`Ȃ炱AVIۑ
					// TEhXV
					p6->SoundUpdate( 0, AVI6::GetAudioBuffer() );
					// ʍXVꂽ AVI1ʕۑ
					if( p6->ScreenUpdate() ) AVI6::AVIWriteFrame( p6->graph->GetSubBuffer() );
				}else{
					// rfILv`łȂȂʏ̍XV
					// TEhXV
					p6->SoundUpdate( 0 );
					// ʍXV}ĂʍXV
					// m[EFCg̎FPSςȂ悤ɂ
					if( p6->sche->IsScreenUpdate() ) p6->ScreenUpdate();
				}
				
				// L[
				if( IsAutoKey() ){
					BYTE key = GetAutoKey();
					if( key ) p6->vm->cpus->ReqKeyIntr( 0, key );
				}
			}
			
			// EFCg
			p6->Wait();
		}
	}
}


////////////////////////////////////////////////////////////////
// Wait
////////////////////////////////////////////////////////////////
void EL6::Wait( void )
{
	if( sche->GetWaitEnable() && (!cfg->GetTurboTAPE() || (vm->cpus->GetCmtStatus() == CMTCLOSE)) )
		sche->VWait();
	vm->evsc->ReVSYNC();
}


////////////////////////////////////////////////////////////////
// 1ߎs
////////////////////////////////////////////////////////////////
int EL6::Emu( void )
{
	int st = vm->Emu();			// VM 1ߎs
	vm->evsc->Update( st );		// CxgXV
	sche->Update( st );
	
	return st;
}


////////////////////////////////////////////////////////////////
// 1ʕs
////////////////////////////////////////////////////////////////
int EL6::EmuVSYNC( void )
{
	int state = 0;
	
	// VSYNC܂ŌJԂ
	while( !vm->evsc->IsVSYNC() ){
		int st = vm->Emu();		// VM 1ߎs
		vm->evsc->Update( st );	// CxgXV
		sche->Update( st );
		state += st;
	}
	
	return state;
}


#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
////////////////////////////////////////////////////////////////
// wXe[gs
////////////////////////////////////////////////////////////////
void EL6::Exec( int st )
{
	int State = st;
	
	while( State > 0 ) State -= Emu();
}


////////////////////////////////////////////////////////////////
// j^[hؑւ
////////////////////////////////////////////////////////////////
bool EL6::ToggleMonitor( void )
{
	// VM~
	Stop();
	
	// j^EBhE\Ԑ؊
	cfg->SetMonDisp( cfg->GetMonDisp() ? false : true );
	
	// u[N|Cg̏NA
	vm->BpClearStatus();
	
	// XN[TCYύX
	graph->ResizeScreen();
	
	// VMĊJ
	Start();
	
	return cfg->GetMonDisp();
}
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
bool EL6::Init( const CFG6 *config )
{
	// G[bZ[Wl
	Error::SetError( Error::InitFailed );
	
	if( !config ) return false;
	cfg = (CFG6 *)config;
	
	// SIuWFNg폜
	DeleteAllObject();
	
	// pbg
	GPal.colors = new COLOR24[256];
	if( !GPal.colors ) return false;
	GPal.ncols = 256;
	
	for( int i=0; i<128; i++ ){
		cfg->GetColor( i, &GPal.colors[i] );
		// XLCpJ[ݒ
		GPal.colors[i+128].r = ( GPal.colors[i].r * cfg->GetScanLineBr() ) / 100;
		GPal.colors[i+128].g = ( GPal.colors[i].g * cfg->GetScanLineBr() ) / 100;
		GPal.colors[i+128].b = ( GPal.colors[i].b * cfg->GetScanLineBr() ) / 100;
	}
	
	// @ VMm
	switch( cfg->GetModel() ){
	case 61: vm = new VM61( this ); break;
	case 62: vm = new VM62( this ); break;
	case 66: vm = new VM66( this ); break;
	default: vm = new VM60( this );
	}
	// VM
	if( !vm || !vm->AllocObject( cfg ) || !vm->Init( cfg ) ) return false;
	vm->vdg->SetColors( &GPal );				// J[e[uݒ
	
	// eIuWFNgm
	try{
		sche   = new SCH6( vm->GetCPUClock() * cfg->GetOverClock() / 100 );	// XPW[
		snd    = new SND6;											// TEh
		graph  = new DSP6( vm );									// ʕ`
		joy    = new JOY6;											// WCXeBbN
		staw   = new cWndStat( vm );								// Xe[^Xo[
		#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		regw   = new cWndReg( vm, DEV_ID("REGW") );					// WX^EBhE
		memw   = new cWndMem( vm, DEV_ID("MEMW") );					// EBhE
		monw   = new cWndMon( vm, DEV_ID("MONW") );					// j^EBhE
		#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	}
	// new Ɏsꍇ
	catch( std::bad_alloc ){
		if( sche ) { delete sche;  sche  = NULL; }
		if( snd )  { delete snd;   snd   = NULL; }
		if( graph ){ delete graph; graph = NULL; }
		if( staw ) { delete staw;  staw  = NULL; }
		if( joy )  { delete joy;   joy   = NULL; }
		if( regw ) { delete regw;  regw  = NULL; }
		if( memw ) { delete memw;  memw  = NULL; }
		if( monw ) { delete monw;  monw  = NULL; }
		
		return false;
	}
	
	// TEh -----
	if( !snd->Init( this, EL6::StreamUpdate, cfg->GetSampleRate(), cfg->GetSoundBuffer() ) ) return false;
	snd->SetVolume( cfg->GetMasterVol() );
	
	// ʕ` -----
	if( !graph->Init() ) return false;
	graph->SetIcon( cfg->GetModel() );	// ACRݒ
	
	// WCXeBbN -----
	if( !joy->Init() ) return false;
	
	// Xe[^Xo[ -----
	if( !staw->Init( graph->ScreenX(), cfg->GetFddNum() ) ) return false;
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// WX^EBhE@-----
	if( !regw->Init() ) return false;
	
	// EBhE@-----
	if( !memw->Init() ) return false;
	
	// j^EBhE@-----
	if( !monw->Init() ) return false;
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// FPS\^C}ݒ
	if( !SetFPSTimer( 1 ) ){
		Stop();
		return false;
	}
	
	// rfILv` -----
	if( !AVI6::Init() ) return false;
	
	// vC -----
	if( !REPLAY::Init( vm->key->GetMatrixSize() ) ) return false;
	
	// XN[TCYύX
	graph->ResizeScreen();
	
	// Xg[ڑ
	snd->ConnectStream( vm->psg );						// PSG
	snd->ConnectStream( vm->cmtl );						// CMT(LOAD)
	if( vm->voice ) snd->ConnectStream( vm->voice );	// 
	
	
	// TAPE}
	if( *(cfg->GetTapeFile()) ) TapeMount( cfg->GetTapeFile() );
	// hCu1,2DISK}
	if( *(cfg->GetDiskFile( 1 )) ) DiskMount( 0, cfg->GetDiskFile( 1 ) );
	if( *(cfg->GetDiskFile( 2 )) ) DiskMount( 1, cfg->GetDiskFile( 2 ) );
	
	
	UI_Reset();
	
	
	// G[Ȃ
	Error::Reset();
	
	return true;
}


////////////////////////////////////////////////////////////////
// Jn
////////////////////////////////////////////////////////////////
bool EL6::Start( void )
{
	FSkipCount = 0;
	
	// Xbh
	if( !this->cThread::BeginThread( this ) ) return false;
	
	sche->Start();
	snd->Play();
	
	return true;
}


////////////////////////////////////////////////////////////////
// ~
////////////////////////////////////////////////////////////////
void EL6::Stop( void )
{
	this->cThread::Cancel();	// XbhItOĂ
	this->cThread::Waiting();	// XbhI܂ő҂
	
	snd->Pause();
	sche->Stop();
}


////////////////////////////////////////////////////////////////
// Cxg[v
////////////////////////////////////////////////////////////////
EL6::ReturnCode EL6::EventLoop( void )
{
	Event event;
	
	while( OSD_GetEvent( &event ) ){
		switch( event.type ){
		case EV_FPSUPDATE:		// FPS\
			{
			char str[256];
			if( sche->GetPauseEnable() )
				sprintf( str, "%s === PAUSE ===", cfg->GetCaption() );
			else
				sprintf( str, "%s (%3d%%  %2d/%2d fps)", cfg->GetCaption(), sche->GetRatio(), event.fps.fps, FRAMERATE );
				if( sche->GetSpeedRatio() != 100 )
					sprintf( str+strlen(str), " [x%3.1f]", (double)sche->GetSpeedRatio()/100 );
					
			OSD_SetWindowCaption( graph->GetWindowHandle(), str );
			}
			break;
			
		case EV_KEYDOWN:		// L[
			#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
			// j^[h?
			if( cfg->GetMonDisp() ){
				monw->KeyIn( event.key.sym, event.key.mod & KVM_SHIFT, event.key.unicode );
				break;
			}else
			#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
			// e@\L[`FbN
			if( CheckFuncKey( event.key.sym,
							  event.key.mod & KVM_ALT  ? true : false,
							  event.key.mod & KVM_META ? true : false ) )
				break;
			// vCĐ or L[͎słȂ
			if( REPLAY::GetStatus() != REP_REPLAY && !IsAutoKey() )
				// L[}gNXXV(L[)
				vm->key->UpdateMatrixKey( event.key.sym, true );
			break;
			
		case EV_KEYUP:
			// vCĐ or L[͎słȂ
			if( REPLAY::GetStatus() != REP_REPLAY && !IsAutoKey() )
				// L[}gNXXV(L[)
				vm->key->UpdateMatrixKey( event.key.sym, false );
			break;
			
		case EV_JOYAXISMOTION:
		case EV_JOYBUTTONDOWN:
		case EV_JOYBUTTONUP:
			// vCĐ or L[͎słȂ
			if( REPLAY::GetStatus() != REP_REPLAY && !IsAutoKey() )
				// L[}gNXXV(WCXeBbN)
				vm->key->UpdateMatrixJoy( joy->GetJoyState( 0 ), joy->GetJoyState( 1 ) );
			break;
			
		#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		case EV_DEBUGMODEBP:	// j^[hύX(u[N|CgB)
			monw->BreakIn( event.bp.addr );		// u[N|Cg̏\
			ToggleMonitor();					// j^[hύX
			
			break;
			
		#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		case EV_MOUSEBUTTONUP:	// }EX{^NbN()
			if( event.mousebt.state != false ) break;
			
			if( event.mousebt.button == MBT_WHEELUP )
				// Xs[hAbv
				sche->SetSpeedRatio( 1 );
			
			if( event.mousebt.button == MBT_WHEELDOWN )
				// Xs[h_E
				sche->SetSpeedRatio( -1 );
			
			if( event.mousebt.button == MBT_LEFT )
				// 
				sche->SetSpeedRatio( 0 );
			
//			if( event.mousebt.button == MBT_MIDDLE ){}
			
			if( event.mousebt.button == MBT_RIGHT ){
				// |bvAbvj[\
				Stop();
				ShowPopupMenu( event.mousebt.x, event.mousebt.y );
				Start();
			}
			break;
			
		case EV_QUIT:			// I
			if( cfg->GetCkQuit() )
				if( OSD_Message( MSG_QUIT, MSG_QUITC, OSDM_YESNO | OSDM_ICONQUESTION ) != OSDR_YES )
					break;
			return Quit;
			
		case EV_RESTART:		// ċN
			return Restart;
			
		case EV_DOKOLOAD:		// ǂłLOAD
			return Dokoload;
			
		case EV_REPLAY:			// vCĐ
			return Replay;
			
		case EV_DROPFILE:		// Drag & Drop
			if( !stricmp( "p6",  OSD_GetFileNameExt( event.drop.file ) ) ||
				!stricmp( "cas", OSD_GetFileNameExt( event.drop.file ) ) ||
				!stricmp( "p6t", OSD_GetFileNameExt( event.drop.file ) ) ){
				UI_TapeInsert( event.drop.file );
			}else if( !stricmp( "d88", OSD_GetFileNameExt( event.drop.file ) ) ){
				UI_DiskInsert( 0, event.drop.file );
			}else if( !stricmp( "rom",  OSD_GetFileNameExt( event.drop.file ) ) ||
				!stricmp( "bin", OSD_GetFileNameExt( event.drop.file ) ) ){
				UI_RomInsert( event.drop.file );
			}else if( !stricmp( "dds", OSD_GetFileNameExt( event.drop.file ) ) ){
				UI_DokoLoad( event.drop.file );
			}else if( !stricmp( "ddr", OSD_GetFileNameExt( event.drop.file ) ) ){
				UI_ReplayLoad( event.drop.file );
			}else if( !stricmp( "bas",  OSD_GetFileNameExt( event.drop.file ) ) ||
				!stricmp( "txt", OSD_GetFileNameExt( event.drop.file ) ) ){
				UI_AutoType( event.drop.file );
			}
			
			// t@CJ
			delete [] event.drop.file;
			break;
			
		default:
			break;
		}
		
		// G[
		switch( Error::GetError() ){
		case Error::NoError:
			break;
			
		default:
			OSD_Message( (char *)Error::GetErrorText(), MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
			Error::Reset();
		}
	}
	return Quit;
}


////////////////////////////////////////////////////////////////
// e@\L[`FbN
////////////////////////////////////////////////////////////////
bool EL6::CheckFuncKey( int kcode, bool OnALT, bool OnMETA )
{
	switch( kcode ){	// L[R[h
	case KVC_F6:		// j^[hύX or XN[[hύX
		// rfILv`͖
		if( AVI6::IsAVI() ) return false;
		
		if( OnALT ){
			Stop();
			cfg->SetFullScreen( cfg->GetFullScreen() ? false : true );
			graph->ResizeScreen();	// XN[TCYύX
			Start();
		}else{
			#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
			ToggleMonitor();
			#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		}
		break;
		
	case KVC_F7:			// XLC[hύX
		// rfILv`͖
		if( AVI6::IsAVI() ) return false;
		
		Stop();
		if( OnALT ){
			cfg->SetDispNTSC( cfg->GetDispNTSC() ? false : true );
		}else{
			cfg->SetScanLine( cfg->GetScanLine() ? false : true );
		}
		graph->ResizeScreen();	// XN[TCYύX
		Start();
		break;
		
	case KVC_F8:			// [h4J[ύX or Xe[^Xo[\ԕύX
		if( OnALT ){
			Stop();
			cfg->SetDispStat( cfg->GetDispStat() ? false : true );
			graph->ResizeScreen();	// XN[TCYύX
			Start();
		}else{
			int c = vm->vdg->GetMode4Color();
			if( ++c > 4 ) c = 0;
			vm->vdg->SetMode4Color( c );
		}
		break;
		
	case KVC_F9:			// |[YLύX
		if( OnALT ){
		}else{
			sche->SetPauseEnable( sche->GetPauseEnable() ? false : true );
		}
		break;
		
	case KVC_F10:			// WaitLύX
		if( OnALT ){
		}else{
			sche->SetWaitEnable( sche->GetWaitEnable() ? false : true );
		}
		break;
		
	case KVC_F11:			// Zbg or ċN
		if( OnALT ){
			OSD_PushEvent( EV_RESTART );
		}else{
			UI_Reset();
		}
		break;
		
	case KVC_F12:			// XibvVbg
		if( OnALT ){
		}else{
			graph->SnapShot( cfg->GetImgPath() );
		}
		break;
		
	case KVX_MENU:			// |bvAbvj[\
		Stop();
		ShowPopupMenu( 0, 0 );
		Start();
		break;


	default:				// ǂłȂ
		return false;
	}
	return true;
}




////////////////////////////////////////////////////////////////
// SIuWFNg폜
////////////////////////////////////////////////////////////////
void EL6::DeleteAllObject( void )
{
	if( UpDateFPSID ) OSD_DelTimer( UpDateFPSID );
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( monw ) { delete monw;	monw = NULL; }
	if( memw ) { delete memw;	memw = NULL; }
	if( regw ) { delete regw;	regw = NULL; }
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	if( staw ) { delete staw;	staw  = NULL; }
	if( joy )  { delete joy;	joy   = NULL; }
	if( snd )  { delete snd;	snd   = NULL; }
	if( graph ){ delete graph;	graph = NULL; }
	if( sche ) { delete sche;	sche  = NULL; }
	if( vm )   { delete vm;		vm    = NULL; }
	
	// L[̓obt@
	if( ak.Buffer ){   delete [] ak.Buffer;		ak.Buffer = NULL; }
	
	// pbg
	if( GPal.colors ){ delete [] GPal.colors;	GPal.colors = NULL; }
}


////////////////////////////////////////////////////////////////
// ʍXV
////////////////////////////////////////////////////////////////
bool EL6::ScreenUpdate( void )
{
	// t[XLbv`FbN
	if( ++FSkipCount > cfg->GetFrameSkip() ){
		// Xe[^Xo[XV
		staw->SetReplayStatus( REPLAY::GetStatus() );	// vCXe[^X
		vm->vdg->UpdateBackBuf();	// obNobt@XV
		graph->DrawScreen();		// ʕ`
		
		#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		if( cfg->GetMonDisp() ){
			regw->Update();
			memw->Update();
			monw->Update();
		}
		#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		
		UDFPSCount++;
		FSkipCount = 0;
		
		return true;
	}
	return false;
}


////////////////////////////////////////////////////////////////
// TEhXV
//
// :	samples		XVTv(-1:cobt@S 0:NbN)
//			exbuf		Oobt@
// Ԓl:	int			XVTv
////////////////////////////////////////////////////////////////
int EL6::SoundUpdate( int samples, cRing *exbuf )
{
	// PSGXV
	vm->psg->SoundUpdate( samples );
	int size = vm->psg->SndDev::cRing::ReadySize();
	
	// CMT(LOAD)XV
	vm->cmtl->SoundUpdate( size );
	
	// XV
	if( vm->voice ) vm->voice->SoundUpdate( size );
	
	// TEhobt@XV
	int ret = snd->PreUpdate( size, exbuf );
	
	return ret;
}


////////////////////////////////////////////////////////////////
// Xg[XV R[obN֐
//
// :	userdata	R[obN֐ɓnf[^(gւ̃IuWFNg|C^)
//			stream		Xg[݃obt@ւ̃|C^
//			len			obt@TCY(oCgP)
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::StreamUpdate( void *userdata, BYTE *stream, int len )
{
	EL6 *p6 = STATIC_CAST( EL6 *, userdata );	// g̃IuWFNg|C^擾
	
	// TEhobt@XV
	//  TvȂ΂Œǉ
	//  rfILv`,|[Y,j^[h̏ꍇ͖
	int addsam = len/sizeof(int16_t) - p6->snd->cRing::ReadySize();
	
	p6->snd->Update( stream, min( (int)(len/sizeof(int16_t)), p6->snd->cRing::ReadySize() ) );
	
	if( addsam > 0 && !p6->AVI6::IsAVI() && !p6->sche->GetPauseEnable()
		#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		&& !p6->cfg->GetMonDisp()
		#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
																		){
		p6->SoundUpdate( addsam );
		p6->snd->Update( stream, addsam );
	}
	
	// ^C~OpEFCg
	p6->sche->WaitReset();
}


////////////////////////////////////////////////////////////////
// FPS\^C} R[obN֐
////////////////////////////////////////////////////////////////
DWORD EL6::UpDateFPS( DWORD interval, void *obj )
{
	EL6 *p6 = STATIC_CAST( EL6 *, obj );	// g̃IuWFNg|C^擾
	
	OSD_PushEvent( EV_FPSUPDATE, p6->UDFPSCount );
	p6->UDFPSCount = 0;
	
	return interval;
}


////////////////////////////////////////////////////////////////
// FPS\^C}ݒ
////////////////////////////////////////////////////////////////
bool EL6::SetFPSTimer( int fps )
{
	// ^C}ғȂ~
	if( UpDateFPSID ){
		OSD_DelTimer( UpDateFPSID );
		UpDateFPSID = NULL;
	}
	
	// ^C}ݒ
	if( fps > 0 )
		UpDateFPSID = OSD_AddTimer( 1000/fps, EL6::UpDateFPS, this );
	
	return UpDateFPSID ? true : false;
}


////////////////////////////////////////////////////////////////
// L[͎s?
//
// :	Ȃ
// Ԓl:	bool	true:s false:słȂ
////////////////////////////////////////////////////////////////
bool EL6::IsAutoKey( void )
{
	return ak.Num ? true : false;
}


////////////////////////////////////////////////////////////////
// L[1擾
//   (VSYNC=1/60secɌĂ΂)
//
// :	Ȃ
// Ԓl:	BYTE	P6̃L[R[h
////////////////////////////////////////////////////////////////
char EL6::GetAutoKey( void )
{
	// [ON҂
	if( ak.RelayOn ){
		if( vm->cmtl->IsRelay() ) ak.RelayOn = false;
		else                      return 0;
	}
	
	// [OFF҂
	if( ak.Relay ){
		if( !vm->cmtl->IsRelay() ) ak.Relay = false;
		else                       return 0;
	}
	
	// ҂?
	if( ak.Wait > 0 ){
		ak.Wait--;
		return 0;
	}
	
	
	// ̕擾
	if( ak.Num-- > 0 ){
		BYTE dat = ak.Buffer[ak.Seek++];
		switch( dat ){
		case 0x17:	// '\w' EFCgݒ
			if( ak.Num-- > 0 ) ak.Wait += (int)((BYTE)ak.Buffer[ak.Seek++]);	// ҂񐔐ݒ
			dat = 0;
			break;
			
		case 0x0a:	// '\r' [OFF҂
			ak.Relay   = true;
			ak.RelayOn = true;
			dat = 0x0d;
		case 0x0d:	// '\n' s?
			ak.Wait = 9;	// ҂9(=150msec)
			break;
			
		default:	// ʂ̕
			ak.Wait = 0;	// ҂Ȃ
		}
		return dat;
	}else{
		// obt@ȂI
		delete [] ak.Buffer;
		ak.Buffer = NULL;
	}
	return 0;
}


////////////////////////////////////////////////////////////////
// L[͕ݒ
//
// :	str		
//			num		̒
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool EL6::SetAutoKey( const char *str, int num )
{
	// L[obt@U폜
	
	// L[obt@m
	if( ak.Buffer ) delete [] ak.Buffer;
	ak.Buffer = new char[num+1];
	if( !ak.Buffer ){
		ak.Num = 0;
		return false;
	}
	
	// Rs[
	strncpy( ak.Buffer, str, num );
	
	ak.Num     = num;	// c蕶
	ak.Wait    = 60;	// ҂񐔃JE^(1sec)
	ak.Relay   = false;	// [XCb`OFF҂tO
	ak.RelayOn = false;	// [XCb`ON҂tO
	ak.Seek    = 0;		// Ǎ݃|C^
	
	return true;
}


////////////////////////////////////////////////////////////////
// L[͕ݒ(t@C)
//
// :	filepath	̓t@Cւ̃pX
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool EL6::SetAutoKeyFile( const char *filepath )
{
	FILE *fp;
	char lbuf[1024];
	
	fp = FOPENEN( filepath, "rb" );
	if( !fp ) return false;
	
	fseek( fp, 0, SEEK_END );
	int tsize = ftell( fp ) + 1;
	fseek( fp, 0, SEEK_SET );
	
	// L[obt@m
	if( ak.Buffer ) delete [] ak.Buffer;
	ak.Buffer = new char[tsize+1];
	if( !ak.Buffer ){
		fclose( fp );
		ak.Num = 0;
		return false;
	}
	ZeroMemory( ak.Buffer, sizeof(ak.Buffer) );
	
	// Ǎ
	// f[^Ȃ܂ŌJԂ
	while( fgets( lbuf, 1024, fp ) ){
		Sjis2P6( lbuf, lbuf );	// SJIS -> P6
		strcat( ak.Buffer, lbuf );
	}
	fclose( fp );
	tsize = strlen( ak.Buffer );
	
	ak.Num     = tsize;	// c蕶
	ak.Wait    = 60;	// ҂񐔃JE^(1sec)
	ak.Relay   = false;	// [XCb`OFF҂tO
	ak.RelayOn = false;	// [XCb`ON҂tO
	ak.Seek    = 0;		// Ǎ݃|C^
	
	return true;
}


////////////////////////////////////////////////////////////////
// I[gX^[gݒ
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::SetAutoStart( void )
{
	char buf[256] = "";
	
	if( !(vm->cmtl->IsMount() && vm->cmtl->IsAutoStart()) ) return;
	
	P6TAUTOINFO *ainf = vm->cmtl->GetAutoStartInfo();
	
	// L[obt@ɏ
	switch( cfg->GetModel() ){
	case 60:	// PC-6001
	case 61:	// PC-6001A
		sprintf( buf, "%c%c", ainf->Page+'0', 0x0d );
		break;
	case 62:	// PC-6001mk2
		switch( ainf->BASIC ){
		case 3:
		case 4:
		case 5:
			if( vm->disk->GetDrives() )	// ??? ۂ?
				sprintf( buf, "%c%c%c%c%c%c%c%c%c%c", 0x17, 50, ainf->BASIC+'0', 0x17, 20, 0x0d, ainf->Page+'0', 0x0d, 0x17, 110 );
			else
				sprintf( buf, "%c%c%c%c%c%c%c%c%c",   0x17, 50, ainf->BASIC+'0', 0x17, 20,       ainf->Page+'0', 0x0d, 0x17, 110 );
			break;
		default:
			sprintf( buf, "%c%c%c%c%c%c%c%c%c", 0x17, 50, ainf->BASIC+'0', 0x17, 20, ainf->Page+'0', 0x0d, 0x17, 10 );
		}
		break;
	case 66:	// PC-6601
		switch( ainf->BASIC ){
		case 3:
		case 4:
		case 5:
			if( vm->disk->IsMount( 0 ) )
				sprintf( buf, "%c%c%c%c%c%c%c%c%c%c", 0x17, 50, ainf->BASIC+'0', 0x17, 20, 0x0d, ainf->Page+'0', 0x0d, 0x17, 110 );
			else
				sprintf( buf, "%c%c%c%c%c%c%c%c%c",   0x17, 50, ainf->BASIC+'0', 0x17, 20,       ainf->Page+'0', 0x0d, 0x17, 110 );
			break;
		default:
			sprintf( buf, "%c%c%c%c%c%c%c%c%c", 0x17, 50, ainf->BASIC+'0', 0x17, 20, ainf->Page+'0', 0x0d, 0x17, 10 );
		}
		break;
//		case 64:	// PC-6001mk2SR
//		case 68:	// PC-6601SR
	}
	memcpy( &buf[strlen(buf)], ainf->ask, ainf->ASKey );
	
	// L[͐ݒ
	if( SetAutoKey( buf, strlen(buf) ) );
}




////////////////////////////////////////////////////////////////
// j^[h?
//
// :	Ȃ
// Ԓl:	bool		true:j^[h false:s
////////////////////////////////////////////////////////////////
#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
bool EL6::IsMonitor( void )
{
	return cfg->GetMonDisp();
}
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


////////////////////////////////////////////////////////////////
// ǂłSAVE
//
// :	filename	t@C
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool EL6::DokoDemoSave( const char *filename )
{
	cIni *Ini = NULL;
	
	// Ƃ肠G[ݒ
	Error::SetError( Error::DokoWriteFailed );
	try{
		FILE *fp = FOPENEN( filename, "wt" );
		if( !fp ) throw Error::DokoWriteFailed;
		// ^Cgso͂ĈU
		fprintf( fp, MSDOKO_TITLE );
		fclose( fp );
		
		// ǂłSAVEt@CJ
		Ini = new cIni();
		if( !Ini->Init( filename ) ) throw Error::DokoWriteFailed;
		
		// eIuWFNg̃p[^
		if( !cfg->DokoSave( Ini )      ||
			!vm->evsc->DokoSave( Ini ) ||
			!vm->intr->DokoSave( Ini ) ||
			!vm->cpum->DokoSave( Ini ) ||
			!vm->cpus->DokoSave( Ini ) ||
			!vm->mem->DokoSave( Ini )  ||
			!vm->vdg->DokoSave( Ini )  ||
			!vm->psg->DokoSave( Ini )  ||
			!vm->pio->DokoSave( Ini )  ||
			!vm->key->DokoSave( Ini )  ||
			!vm->cmtl->DokoSave( Ini ) ||
			!vm->disk->DokoSave( Ini )
		) throw Error::GetError();
		if( vm->voice && !vm->voice->DokoSave( Ini ) ) throw Error::GetError();
	}
	catch( std::bad_alloc ){	// new Ɏsꍇ
		Error::SetError( Error::MemAllocFailed );
		return false;
	}
	catch( Error::Errno i ){	// O
		Error::SetError( i );
		if( Ini ) delete Ini;
		return false;
	}
	
	Ini->Write();
	
	delete Ini;
	
	// ̂ŃG[Ȃ
	Error::Reset();
	
	return true;
}


////////////////////////////////////////////////////////////////
// ǂłLOAD
//
// :	filename	t@C
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool EL6::DokoDemoLoad( const char *filename )
{
	cIni *Ini = NULL;
	
	// Ƃ肠G[ݒ
	Error::SetError( Error::DokoReadFailed );
	try{
		// ǂłLOADt@CJ
		Ini = new cIni();
		if( !Ini->Init( filename ) ) throw Error::DokoReadFailed;
//		cfg->SetDokoFile( filename );
		
		// PC6001Ṽo[WmFƎv\Ǎ
		// (@,FDD䐔,gRAM,ROMpb`,m̃J[gbW)
		if( !cfg->DokoLoad( Ini ) ) throw Error::GetError();
		
		// VMď
		Init( cfg );
		
		// eIuWFNg̃p[^Ǎ
		if(	!vm->evsc->DokoLoad( Ini ) ||
			!vm->intr->DokoLoad( Ini ) ||
			!vm->cpum->DokoLoad( Ini ) ||
			!vm->cpus->DokoLoad( Ini ) ||
			!vm->mem->DokoLoad( Ini )  ||
			!vm->vdg->DokoLoad( Ini )  ||
			!vm->psg->DokoLoad( Ini )  ||
			!vm->pio->DokoLoad( Ini )  ||
			!vm->key->DokoLoad( Ini )  ||
			!vm->cmtl->DokoLoad( Ini ) ||
			!vm->disk->DokoLoad( Ini )
		) throw Error::GetError();
		if( vm->voice && !vm->voice->DokoLoad( Ini ) ) throw Error::GetError();
		
		// fBXNhCuɂăXN[TCYύX
		if( !staw->Init( -1, vm->disk->GetDrives() ) ) throw Error::GetError();
		if( !graph->ResizeScreen() ) throw Error::GetError();
	}
	catch( std::bad_alloc ){	// new Ɏsꍇ
		Error::SetError( Error::MemAllocFailed );
		return false;
	}
	catch( Error::Errno i ){	// O
		Error::SetError( i );
		if( Ini ) delete Ini;
		return false;
	}
	
	delete Ini;
//	cfg->SetDokoFile( "" );
	
	// ̂ŃG[Ȃ
	Error::Reset();
	
	return true;
}


////////////////////////////////////////////////////////////////
// ǂłLOADt@C@햼Ǎ
//
// :	filename	t@C
// Ԓl:	int			@햼(60,61,62,66)
////////////////////////////////////////////////////////////////
int EL6::GetDokoModel( const char *filename )
{
	cIni *Ini = NULL;
	int st;
	
	try{
		// ǂłLOADt@CJ
		Ini = new cIni();
		if( !Ini->Init( filename ) ) throw Error::DokoReadFailed;
		
		// @擾
		Ini->GetInt( "GLOBAL", "Model",	&st, 0 );
	}
	catch( std::bad_alloc ){	// new Ɏsꍇ
		Error::SetError( Error::MemAllocFailed );
		return 0;
	}
	catch( Error::Errno i ){	// O
		Error::SetError( i );
		if( Ini ) delete Ini;
		return 0;
	}
	
	delete Ini;
	
	return st;
}







////////////////////////////////////////////////////////////////
// TAPE }Eg
//
// :	filename	t@C
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool EL6::TapeMount( const char *filename )
{
	if( !vm->cmtl->Mount( filename ) ) return false;
	return true;
}


////////////////////////////////////////////////////////////////
// TAPE A}Eg
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::TapeUnmount( void )
{
	vm->cmtl->Unmount();
}


////////////////////////////////////////////////////////////////
// DISK }Eg
//
// :	drv			hCuԍ
//			filename	t@C
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool EL6::DiskMount( int drv, const char *filename )
{
	if( !vm->disk->Mount( drv, filename ) ) return false;
	return true;
}


////////////////////////////////////////////////////////////////
// DISK A}Eg
//
// :	drv			hCuԍ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::DiskUnmount( int drv )
{
	vm->disk->Unmount( drv );
}







////////////////////////////////////////////////////////////////
// vCۑJn
//
// :	filename	t@C
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool EL6::ReplayRecStart( const char *filename )
{
	return REPLAY::StartRecord( filename );
}


////////////////////////////////////////////////////////////////
// vCۑ~
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::ReplayRecStop( void )
{
	REPLAY::StopRecord();
}


////////////////////////////////////////////////////////////////
// vCĐJn
//
// :	filename	t@C
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::ReplayPlayStart( const char *filename )
{
	cfg->SetModel( GetDokoModel( filename ) );
	cfg->SetDokoFile( filename );
	OSD_PushEvent( EV_REPLAY );
}


////////////////////////////////////////////////////////////////
// vCĐ~
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::ReplayPlayStop( void )
{
	REPLAY::StopReplay();
}







////////////////////////////////////////////////////////////////
// UI:TAPE }
//
// :	path		t@C
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_TapeInsert( const char *path )
{
	char str[PATH_MAX];
	const char *fpath = path;
	
	if( !path ){
		if( !OSD_FileExist( TapePathUI ) )
			strncpy( TapePathUI, cfg->GetTapePath(), PATH_MAX );
		if( OSD_FileSelect( graph->GetWindowHandle(), FD_TapeLoad, str, TapePathUI ) )
			fpath = str;
	}
	if( !fpath ) return;
	
	if( !TapeMount( fpath ) ) Error::SetError( Error::TapeMountFailed );
}



////////////////////////////////////////////////////////////////
// UI:DISK }
//
// :	drv			hCuԍ
//			path		t@C
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_DiskInsert( int drv, const char *path )
{
	char str[PATH_MAX];
	const char *fpath = path;
	
	if( !path ){
		if( !OSD_FileExist( DiskPathUI ) )
			strncpy( DiskPathUI, cfg->GetDiskPath(), PATH_MAX );
		if( OSD_FileSelect( graph->GetWindowHandle(), FD_Disk, str, DiskPathUI ) )
			fpath = str;
	}
	if( !fpath ) return;
	
	if( !DiskMount( drv, fpath ) ) Error::SetError( Error::DiskMountFailed );
}


////////////////////////////////////////////////////////////////
// UI:gROM }
//
// :	path		t@C
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_RomInsert( const char *path )
{
	char str[PATH_MAX];
	const char *fpath = path;
	
	if( !path ){
		if( !OSD_FileExist( ExRomPathUI ) )
			strncpy( ExRomPathUI, cfg->GetExtRomPath(), PATH_MAX );
		if( OSD_FileSelect( graph->GetWindowHandle(), FD_ExtRom, str, ExRomPathUI ) )
			fpath = str;
	}
	if( !fpath ) return;
	
	// Zbg𔺂̂ŃbZ[W\
	OSD_Message( MSG_RESETI, MSG_RESETC, OSDM_OK | OSDM_ICONINFO );
	if( !vm->mem->MountExtRom( fpath ) )
		Error::SetError( Error::ExtRomMountFailed );
	else
		UI_Reset();
}


////////////////////////////////////////////////////////////////
// UI:gROM ro
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_RomEject( void )
{
	// Zbg𔺂̂ŃbZ[W\
	OSD_Message( MSG_RESETE, MSG_RESETC, OSDM_OK | OSDM_ICONINFO );
	vm->mem->UnmountExtRom();
	UI_Reset();
}


////////////////////////////////////////////////////////////////
// UI:ǂłSAVE
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_DokoSave( void )
{
	char str[PATH_MAX];
	
	if( OSD_FileSelect( graph->GetWindowHandle(), FD_DokoSave, str, (char *)OSD_GetModulePath() ) )
	DokoDemoSave( str );
}


////////////////////////////////////////////////////////////////
// UI:ǂłLOAD
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_DokoLoad( const char *path )
{
	char str[PATH_MAX];
	const char *fpath = path;
	
	if( !path && OSD_FileSelect( graph->GetWindowHandle(), FD_DokoLoad, str, (char *)OSD_GetModulePath() ) )
		fpath = str;
	
	if( !fpath ) return;
	
	cfg->SetModel( GetDokoModel( fpath ) );
	cfg->SetDokoFile( fpath );
	OSD_PushEvent( EV_DOKOLOAD );
}


////////////////////////////////////////////////////////////////
// UI:vCۑ
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_ReplaySave( void )
{
	char str[PATH_MAX];
	
	if( REPLAY::GetStatus() == REP_IDLE ){
		if( OSD_FileSelect( graph->GetWindowHandle(), FD_RepSave, str, (char *)OSD_GetModulePath() ) ){
			if( DokoDemoSave( str ) ) ReplayRecStart( str );
		}
	}else if( REPLAY::GetStatus() == REP_RECORD ){
		ReplayRecStop();
	}
}


////////////////////////////////////////////////////////////////
// UI:vCĐ
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_ReplayLoad( const char *path )
{
	char str[PATH_MAX];
	const char *fpath = path;
	
	if( REPLAY::GetStatus() == REP_IDLE ){
		if( !path && OSD_FileSelect( graph->GetWindowHandle(), FD_RepLoad, str, (char *)OSD_GetModulePath() ) )
			fpath = str;
	}else if( REPLAY::GetStatus() == REP_REPLAY ){
		ReplayPlayStop();
	}
	
	if( !fpath ) return;
	
	ReplayPlayStart( fpath );
}


////////////////////////////////////////////////////////////////
// UI:rfILv`
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_AVISave( void )
{
	char str[PATH_MAX];
	
	if( !AVI6::IsAVI() ){
		if( OSD_FileSelect( graph->GetWindowHandle(), FD_AVISave, str, (char *)OSD_GetModulePath() ) ){
			AVI6::StartAVI( str, graph->GetSubBuffer(), FRAMERATE, cfg->GetSampleRate(), cfg->GetAviBpp() );
		}
	}else{
		AVI6::StopAVI();
	}
}


////////////////////////////////////////////////////////////////
// UI:ōݑs
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_AutoType( const char *path )
{
	char str[PATH_MAX];
	const char *fpath = path;
	
	if( !path && OSD_FileSelect( graph->GetWindowHandle(), FD_LoadAll, str, (char *)OSD_GetModulePath() ) )
		fpath = str;
	
	if( !fpath ) return;
	
	if( !SetAutoKeyFile( fpath ) ) Error::SetError( Error::Unknown );
}


////////////////////////////////////////////////////////////////
// UI:Zbg
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_Reset( void )
{
	// VXefBXNĂTAPẼI[gX^[g
	if( !vm->disk->IsSystem(0) && !vm->disk->IsSystem(1) )
		SetAutoStart();
	vm->Reset();
}


////////////////////////////////////////////////////////////////
// UI:ċN
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_Restart( void )
{
	OSD_PushEvent( EV_RESTART );
}


////////////////////////////////////////////////////////////////
// UI:I
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_Quit( void )
{
	OSD_PushEvent( EV_QUIT );
}


////////////////////////////////////////////////////////////////
// UI:WaitύX
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_NoWait( void )
{
	sche->SetWaitEnable( sche->GetWaitEnable() ? false : true );
}


////////////////////////////////////////////////////////////////
// UI:Turbo TAPEύX
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_TurboTape( void )
{
	cfg->SetTurboTAPE( cfg->GetTurboTAPE() ? false : true );
}


////////////////////////////////////////////////////////////////
// UI:Boost UpύX
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_BoostUp( void )
{
	cfg->SetBoostUp( cfg->GetBoostUp() ? false : true );
	vm->cmtl->SetBoost( vm->cmtl->IsBoostUp() ? false : true );
}


////////////////////////////////////////////////////////////////
// UI:XLC[hύX
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_ScanLine( void )
{
	// rfILv`͖
	if( !AVI6::IsAVI() ){
		cfg->SetScanLine( cfg->GetScanLine() ? false : true );
		graph->ResizeScreen();	// XN[TCYύX
	}
}


////////////////////////////////////////////////////////////////
// UI:4:3\ύX
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_Disp43( void )
{
	// rfILv`͖
	if( !AVI6::IsAVI() ){
		cfg->SetDispNTSC( cfg->GetDispNTSC() ? false : true );
		graph->ResizeScreen();	// XN[TCYύX
	}
}


////////////////////////////////////////////////////////////////
// UI:Xe[^Xo[\ԕύX
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_StatusBar( void )
{
	cfg->SetDispStat( cfg->GetDispStat() ? false : true );
	graph->ResizeScreen();	// XN[TCYύX
}


////////////////////////////////////////////////////////////////
// UI:MODE4J[ύX
//
// :	col			0:mN 1:/ 2:/ 3:sN/ 4:/sN
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_Mode4Color( int col )
{
	cfg->SetMode4Color( col );
	vm->vdg->SetMode4Color( col );
}


////////////////////////////////////////////////////////////////
// UI:t[XLbvύX
//
// :	sk			t[XLbv
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_FrameSkip( int sk )
{
	if( !AVI6::IsAVI() ) cfg->SetFrameSkip( sk );
}


////////////////////////////////////////////////////////////////
// UI:TvO[gύX
//
// :	rate		TvO[g(Hz)
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_SampleRate( int rate )
{
	cfg->SetSampleRate( rate );
	snd->SetSampleRate( rate );
}


////////////////////////////////////////////////////////////////
// UI:ݒ
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::UI_Config( void )
{
	cfg->Write();
	if( OSD_ConfigDialog( graph->GetWindowHandle() ) > 0 )
		// ċN?
		if( OSD_Message( MSG_RESTART, MSG_RESTARTC, OSDM_YESNO | OSDM_ICONQUESTION ) == OSDR_YES )
			OSD_PushEvent( EV_RESTART );
}


////////////////////////////////////////////////////////////////
// j[Iڎs
//
// :	id		Ij[ID
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void EL6::ExecMenu( int id )
{
	// ڂƂ̏
	switch( id ){
	case ID_TAPEINSERT:		UI_TapeInsert();						break;	// TAPE }
	case ID_TAPEEJECT:		TapeUnmount();							break;	// TAPE ro
	case ID_DISKINSERT1:													// DISK }
	case ID_DISKINSERT2:	UI_DiskInsert( id - ID_DISKINSERT1 );	break;
	case ID_DISKEJECT1:														// DISK ro
	case ID_DISKEJECT2:		DiskUnmount( id - ID_DISKEJECT1 );		break;
	case ID_ROMINSERT:		UI_RomInsert();							break;	// gROM }
	case ID_ROMEJECT:		UI_RomEject();							break;	// gROM ro
	case ID_JOY100:															// WCXeBbN1
	case ID_JOY101:
	case ID_JOY102:
	case ID_JOY103:
	case ID_JOY104:
	case ID_JOY105:			joy->Connect( 0, id - ID_JOY101 );		break;
	case ID_JOY200:															// WCXeBbN2
	case ID_JOY201:
	case ID_JOY202:
	case ID_JOY203:
	case ID_JOY204:
	case ID_JOY205:			joy->Connect( 1, id - ID_JOY201 );		break;
	case ID_CONFIG:			UI_Config();							break;	// ݒ
	case ID_RESET:			UI_Reset();								break;	// Zbg
	case ID_RESTART:		UI_Restart();							break;	// ċN
	case ID_DOKOSAVE:		UI_DokoSave();							break;	// ǂłSAVE
	case ID_DOKOLOAD:		UI_DokoLoad();							break;	// ǂłLOAD
	case ID_REPLAYSAVE:		UI_ReplaySave();						break;	// vCۑ
	case ID_REPLAYLOAD:		UI_ReplayLoad();						break;	// vCĐ
	case ID_AVISAVE:		UI_AVISave();							break;	// rfILv`
	case ID_AUTOTYPE:		UI_AutoType();							break;	// ōݑs
	case ID_QUIT:			UI_Quit();								break;	// I
	case ID_NOWAIT:			UI_NoWait();							break;	// WaitLύX
	case ID_TURBO:			UI_TurboTape();							break;	// Turbo TAPE
	case ID_BOOST:			UI_BoostUp();							break;	// Boost Up
	case ID_SCANLINE:		UI_ScanLine();							break;	// XLC[hύX
	case ID_DISP43:			UI_Disp43();							break;	// 4:3\ύX
	case ID_STATUS:			UI_StatusBar();							break;	// Xe[^Xo[\ԕύX
	case ID_M4MONO:															// MODE4J[ mN
	case ID_M4RDBL:															// MODE4J[ /
	case ID_M4BLRD:															// MODE4J[ /
	case ID_M4PKGR:															// MODE4J[ sN/
	case ID_M4GRPK:			UI_Mode4Color( id - ID_M4MONO );		break;	// MODE4J[ /sN
	case ID_FSKP0:															// t[XLbv Ȃ
	case ID_FSKP1:															// t[XLbv 1
	case ID_FSKP2:															// t[XLbv 2
	case ID_FSKP3:															// t[XLbv 3
	case ID_FSKP4:															// t[XLbv 4
	case ID_FSKP5:			UI_FrameSkip( id - ID_FSKP0 );			break;	// t[XLbv 5
	case ID_SPR44:															// TvO[g 44100Hz
	case ID_SPR22:															// TvO[g 22050Hz
	case ID_SPR11:			UI_SampleRate( 44100 >> (id - ID_SPR44 ) );	break;	// TvO[g 11025Hz
	case ID_VERSION:		OSD_VersionDialog( graph->GetWindowHandle(), cfg->GetModel() );	break;	// o[W
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	case ID_MONITOR:		ToggleMonitor();						break;	// j^[[h
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	}
}
