#ifndef P6EL_H_INCLUDED
#define P6EL_H_INCLUDED

#include "typedef.h"
#include "movie.h"
#include "replay.h"
#include "thread.h"
#include "vsurface.h"


class VM6;
class CFG6;
class DSP6;
class SND6;
class SCH6;
class JOY6;
class cWndStat;

#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
class cWndReg;
class cWndMem;
class cWndMon;
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
// G~[^C[NX
class EL6 : public cThread, public AVI6, public REPLAY {
	
	friend class VM6;
	friend class DSP6;
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	friend class cWndMon;
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
public:
	enum ReturnCode {
		Quit = 0,
		Restart,
		Dokoload,
		Replay,
		Error,
		
		EndofReturnCode
	};
	
protected:
	// IuWFNg|C^
	VM6 *vm;					// VM
	CFG6 *cfg;					// ݒIuWFNg
	SCH6 *sche;					// XPW[
	DSP6 *graph;				// ʕ`
	SND6 *snd;					// TEh
	JOY6 *joy;					// WCXeBbN
	
	cWndStat *staw;				// Xe[^Xo[
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	cWndReg *regw;				// WX^EBhE
	cWndMem *memw;				// EBhE
	cWndMon *monw;				// j^EBhE
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	HTIMERID UpDateFPSID;		// FPS\^C}ID
	VPalette GPal;				// pbg
	int UDFPSCount;				// FPS\^C}JE^
	int FSkipCount;				// t[XLbvJE^
	
	
	void DeleteAllObject();					// SIuWFNg폜
	
	bool ScreenUpdate();					// ʍXV
	int SoundUpdate( int, cRing * = NULL );	// TEhXV
	static void StreamUpdate( void *, BYTE *, int);		// Xg[XV R[obN֐
	static DWORD UpDateFPS( DWORD, void * );	// FPS\^C} R[obN֐
	bool SetFPSTimer( int );				// FPS\^C}ݒ
	
	void OnThread( void * );				// Xbh֐
	
	int Emu();								// 1ߎs
	int EmuVSYNC();							// 1ʕs
	void Wait();							// Wait
	
	bool CheckFuncKey( int, bool, bool );	// e@\L[`FbN
	
	// L[͏\
	struct AKEY{
		char *Buffer;			// L[obt@|C^
		int Num;				// c蕶
		int Wait;				// ҂񐔃JE^
		bool Relay;				// [XCb`OFF҂tO
		bool RelayOn;			// [XCb`OB҂tO
		int Seek;
		
		AKEY() : Buffer(NULL), Num(0), Wait(0), Relay(false), Seek(0) {}
	};
	AKEY ak;								// L[͏
	
	char GetAutoKey();						// L[1擾
	
	
	// UI֘A
	char TapePathUI[PATH_MAX];	// TAPEpX
	char DiskPathUI[PATH_MAX];	// DISKpX
	char ExRomPathUI[PATH_MAX];	// gROMpX
	
	void UI_TapeInsert( const char * = NULL );		// TAPE }
	void UI_DiskInsert( int, const char * = NULL );	// DISK }
	void UI_RomInsert( const char * = NULL );		// gROM }
	void UI_RomEject();								// gROM ro
	void UI_DokoSave();								// ǂłSAVE
	void UI_DokoLoad( const char * = NULL );		// ǂłLOAD
	void UI_ReplaySave();							// vCۑ
	void UI_ReplayLoad( const char * = NULL );		// vCĐ
	void UI_AVISave();								// rfILv`
	void UI_AutoType( const char * = NULL );		// ōݑs
	void UI_Reset();						// Zbg
	void UI_Restart();						// ċN
	void UI_Quit();							// I
	void UI_NoWait();						// WaitύX
	void UI_TurboTape();					// Turbo TAPEύX
	void UI_BoostUp();						// Boost UpύX
	void UI_ScanLine();						// XLC[hύX
	void UI_Disp43();						// 4:3\ύX
	void UI_StatusBar();					// Xe[^Xo[\ԕύX
	void UI_Mode4Color( int );				// MODE4J[ύX
	void UI_FrameSkip( int );				// t[XLbvύX
	void UI_SampleRate( int );				// TvO[gύX
	void UI_Config();						// ݒ
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	void Exec( int );						// wXe[gs
	bool ToggleMonitor();					// j^[hؑւ
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	void ShowPopupMenu( int, int );			// |bvAbvj[\
	void ExecMenu( int );					// j[Iڎs
	
	bool TapeMount( const char * );			// TAPE }Eg
	void TapeUnmount();						// TAPE A}Eg
	bool DiskMount( int, const char * );	// DISK }Eg
	void DiskUnmount( int );				// DISK A}Eg
	
	bool ReplayRecStart( const char * );	// vCۑJn
	void ReplayRecStop();					// vCۑ~
	void ReplayPlayStart( const char * );	// vCĐJn
	void ReplayPlayStop();					// vCĐ~
	
	bool IsAutoKey();						// L[͎s?
	bool SetAutoKeyFile( const char * );	// L[͕ݒ(t@C)
	bool SetAutoKey( const char *, int );	// L[͕ݒ
	void SetAutoStart();					// I[gX^[gݒ
	
public:
	EL6();									// RXgN^
	~EL6();									// fXgN^
	
	bool Init( const CFG6 * );				// 
	
	bool Start();							// Jn
	void Stop();							// ~
	
	ReturnCode EventLoop();					// Cxg[v
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	bool IsMonitor();						// j^[h?
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// ------------------------------------------
	bool DokoDemoSave( const char * );	// ǂłSAVE
	bool DokoDemoLoad( const char * );	// ǂłLOAD
	int GetDokoModel( const char * );	// ǂłLOADt@C@햼Ǎ
	// ------------------------------------------
};


#endif		// P6EL_H_INCLUDED
