#ifndef P6T2_H_INCLUDED
#define P6T2_H_INCLUDED

#include "typedef.h"
#include "ini.h"


// P6T ubN
struct P6TBLKINFO {
	int STime;				// ̎(ms)
	int PTime;				// ҁ[̎(ms)
	int Offset;				// x^C[W擪̃ItZbg
	int DNum;				// f[^TCY
	
	P6TBLKINFO() : STime(0), PTime(0), Offset(0), DNum(0) {}
};

// DATAubNNX
class cP6DATA {
private:
	P6TBLKINFO Info;					// P6T ubN
	BYTE *Data;							// f[^ւ̃|C^
	
	cP6DATA *next;						// DATAubNւ̃|C^
	cP6DATA *before;					// ODATAubNւ̃|C^
	
	cP6DATA *TopBlock();				// 擪ubNւ̃|C^Ԃ
	cP6DATA *LastBlock();				// ubNւ̃|C^Ԃ
	
public:
	cP6DATA();							// RXgN^
	~cP6DATA();							// fXgN^
	
	cP6DATA *Next();					// ̃ubNւ̃|C^Ԃ
	cP6DATA *Before();					// ÕubNւ̃|C^Ԃ
	
	cP6DATA *New();						// VKDATAubNǉ
	cP6DATA *Clone();					// Rs[쐬
	cP6DATA *Clones();					// SRs[쐬
	
	P6TBLKINFO *GetInfo();				// P6T ubN擾
	
	int SetData( FILE *, int );			// f[^Zbg
	void SetPeriod( int, int );			// ,ҁ[ԃZbg
	
	BYTE Read( int );					// 1ByteǍ
	
	int Writefd( FILE * );				// t@Cɏ(f[^)
};


// P6T PART
struct P6TPRTINFO {
	BYTE ID;				// IDԍ
	char Name[17];			// f[^(16+'00H')
	WORD Baud;				// {[[g(600/1200)
	
	P6TPRTINFO() : ID(0), Baud(1200)
	{
		INITARRAY( Name, 0 );
	}
};

// PARTNX
class cP6PART {
private:
	P6TPRTINFO Info;						// P6T PART
	cP6DATA *Data;							// 擪DATAubNւ̃|C^
	
	cP6PART *next;							// PARTւ̃|C^
	cP6PART *before;						// OPARTւ̃|C^
	
	cP6PART *TopPart();						// 擪PARTւ̃|C^Ԃ
	cP6PART *LastPart();					// PARTւ̃|C^Ԃ
	
	BYTE Renumber();						// IDԍio[
	
public:
	cP6PART();								// RXgN^
	~cP6PART();								// fXgN^
	
	cP6PART *Next();						// PARTւ̃|C^Ԃ
	cP6PART *Before();						// OPARTւ̃|C^Ԃ
	cP6PART *Part( int );					// CӂPARTւ̃|C^Ԃ
	
	cP6PART *New();							// VKPARTǉ
	cP6PART *Clone();						// Rs[쐬
	cP6PART *Link( cP6PART * );				// PARTA
	
	cP6DATA *NewBlock();					// VKDATAubNǉ
	
	int GetBlocks();						// SDATAubN擾
	int GetSize();							// PARTTCY擾
	
	cP6DATA *FirstData();					// 擪DATAubNւ̃|C^擾
	
	P6TPRTINFO *GetInfo();					// P6T PART擾
	
	int SetName( const char * );			// f[^ݒ
	void SetBaud( int );					// {[[gݒ
	
	bool Readf( FILE * );					// t@CSPARTǍ
	int Writefd( FILE * );					// t@Cɏ(f[^)
	bool Writeff( FILE * );					// t@Cɏ(tb^)
};


// I[gX^[g
struct P6TAUTOINFO {
	bool Start;				// I[gX^[gtO
	BYTE BASIC;				// BASIC[h(PC-6001̏ꍇ͖Ӗ)
	BYTE Page;				// y[W
	WORD ASKey;				// I[gX^[gR}hTCY
	char *ask;				// I[gX^[gR}hi[̈ւ̃|C^
	
	P6TAUTOINFO() : Start(false), BASIC(1), Page(1), ASKey(0), ask(NULL) {}
};

// P6TNX
class cP6T : public IDoko {
private:
	char Name[17];							// f[^(16+'00H')
	BYTE Version;							// o[W
	
	P6TAUTOINFO Ainfo;						// I[gX^[g
	
	WORD EHead;								// gTCY(64KB܂)
	char *exh;								// gi[̈ւ̃|C^
	
	cP6PART *Part;							// 擪PARTւ̃|C^
	
	// Ǎ݊֌W[N
	cP6PART *rpart;							// ݂̓ǍPART
	cP6DATA *rdata;							// ݂̓ǍDATAubN
	int rpt;								// ݂̓Ǎ݃|C^(DATAubN)
	int swait;								// ̑҂
	int pwait;								// ҁ[̑҂
	
	bool ReadP6T( const char * );			// P6TǍ
	bool ConvP6T( const char * );			// x^P6TɕϊēǍ
	
public:
	cP6T();									// RXgN^
	virtual ~cP6T();						// fXgN^
	
	int GetBlocks();						// SDATAubN擾
	int GetParts();							// SPART擾
	
	cP6PART *GetPart( int );				// CPARTւ̃|C^擾
	
	int SetName( const char * );			// f[^ݒ
	const char *GetName();					//         擾
	
	P6TAUTOINFO *GetAutoStartInfo();		// I[gX^[g擾
	
	int GetSize();							// x^C[WTCY擾
	
	BYTE ReadOne();							// 1Ǎ
	
	bool IsSWaiting();						// ҂?
	bool IsPWaiting();						// ҁ[҂?
	
	bool Readf( const char * );				// t@CǍ
	bool Writef( const char * );			// t@Cɏ
	
	int GetCount();							// TAPEJE^擾
	void SetCount( int );					//             ݒ
	
	void Reset();							// Zbg(Ǎ݊֌W[N)
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};



#endif	// P6T2_H_INCLUDED
