#ifndef SCHEDULE_H_INCLUDED
#define SCHEDULE_H_INCLUDED

#include "typedef.h"
#include "device.h"
#include "ini.h"
#include "thread.h"


// őCxg
#define	MAXEVENT	(32)

// CxgX^CtO
// bit0: JԂw
#define	EV_ONETIME	(0x00)	/* ^C */
#define	EV_LOOP		(0x01)	/* [v */
// bit1,2: wP
#define	EV_HZ		(0x00)	/* Hz */
#define	EV_US		(0x02)	/* us */
#define	EV_MS		(0x04)	/* ms */
#define	EV_STATE	(0x08)	/* CPUXe[g */

// xvZpۑ̈TCY
#define	SPDCNT		(5)


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
// VMCxgXPW[NX
class EVSC : public IDoko {
public:
	// Cxg\
	struct evinfo {
		Device::ID devid;		// CxgfoCXIuWFNgID
		int id;					// CxgID
		bool Active;			// CxgLtO true:L false:~
		int Period;				// 1̃NbN
		int Clock;				// cNbN
		double nps;				// Cxgg(Hz)
		
		evinfo() : devid(0), id(0), Active(false), Period(0), Clock(0), nps(0) {}
	};
	
protected:
	evinfo ev[MAXEVENT];		// Cxg
	DeviceList devlist;			// foCXXg
	
	bool VSYNC;					// VSYNCtO true:VSYNCɒB false:BĂȂ
	
	int MasterClock;			// }X^NbN({IɂCPUXe[g/bɂȂ͂)
	int NextEvent;				// ̃Cxg܂ł̃NbN
	int SaveClock;				// NbN𗭂ߍ
	
	evinfo *Find( Device::ID, int );			// Cxg
	
public:
	EVSC( int );								// RXgN^
	virtual ~EVSC();							// fXgN^
	
	bool Entry( Device * );						// ڑfoCXo^
	bool Add( Device *, int, double, int );		// Cxgǉ
	bool Del( Device *, int );					// Cxg폜
	
	bool SetHz( Device::ID, int, double );		// Cxggݒ
	
	void Update( int );							// CxgXV
	void Reset( Device::ID, int, double=0 );	// wCxgZbg
	
	int Rest( Device::ID, int );				// Cxg܂ł̎cNbN߂
	double Scale( Device::ID, int );			// Cxg̐is߂
	
	bool GetEvinfo( evinfo * );					// Cxg擾
	bool SetEvinfo( evinfo * );					// Cxgݒ
	
	void SetMasterClock( int );					// }X^NbNݒ
	int GetMasterClock();						// }X^NbN擾
	
	bool IsVSYNC();								// VSYNCɒB?
	void OnVSYNC();								// VSYNCʒm
	void ReVSYNC();								// VSYNCtOLZ
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


// G~[^XPW[NX
class SCH6 : public cThread, public cSemaphore {
protected:
	bool WaitEnable;		// WaitLtO
	bool PauseEnable;		// |[YLtO
	int EnableScrUpdate;	// ʍXVtO
	
	int SpeedRatio;			// sx
	int SpeedCnt1;			// sxpJE^1
	int SpeedCnt2;			// sxpJE^2
	
	// xvZp
	int MasterClock;		// }X^NbN
	DWORD WRClock[SPDCNT];	// NbNۑ
	
	void OnThread( void * );					// Xbh֐
	
public:
	SCH6( int );								// RXgN^
	virtual ~SCH6();							// fXgN^
	
//	void CalcCpuState();						// ʂ̕\ԂɉCPUXe[gvZ
	
	bool Start();								// Jn
	void Stop();								// ~
	
	bool GetWaitEnable();						// WaitLtO擾
	void SetWaitEnable( bool );					//               ݒ
	
	bool GetPauseEnable();						// |[YLtO擾
	void SetPauseEnable( bool );				//                 ݒ
	
	void VWait();								// VSYNC Wait
	void WaitReset();							// Wait
	
	void SetSpeedRatio( int );					// sxݒ
	int GetSpeedRatio();						//         擾
	
	void Update( int );							// CxgXV
	int GetRatio();								// sx擾
	
	bool IsScreenUpdate();						// ʍXV}?
};

#endif	// SCHEDULE_H_INCLUDED
