#ifndef VDG_H_INCLUDED
#define VDG_H_INCLUDED

#include "typedef.h"
#include "device.h"
#include "ini.h"
#include "vsurface.h"
#include "device/mc6847.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class VDG6 : public Device, public VSurface, public virtual MC6847core, public IDoko {
protected:
	static const BYTE NJM6_TBL[][2];			// Fɂ݃J[R[he[u
	
	BYTE AddrOff;								// VRAM,ATTRItZbg(Bit1,2)
	
	// M[N
	int VLcnt;									// \CJE^
	bool OnDisp;								// \ԃtO
	int HSdclk;									// g[^(hbgNbN)
	int Hclk60;									// \(N60)
	
	BYTE *GetBufAddr();							// obt@AhX擾
	int GetBufPitch();							// obt@sb`(1LineoCg)擾
	int GetBufHeight();							// obt@擾
	
	void LatchAttr();							// Agr[gf[^b`
	void LatchGMODE();							// Agr[gf[^b`(OtBbN[ĥ)
	BYTE GetAttr();								// Agr[gf[^擾
	BYTE GetVram();								// VRAMf[^擾
	BYTE GetFont1( WORD );						// Font1f[^擾
	
	virtual WORD GerVramAddr() = 0;				// VRAMAhX擾
	virtual WORD GerAttrAddr() = 0;				// ATTRAhX擾
	
public:
	VDG6( VM6 *, const ID& );					// RXgN^
	virtual ~VDG6();							// fXgN^
	
	void EventCallback( int, int );				// CxgR[obN֐
	
	virtual bool Init();						// 
	bool IsDisp();								// \ԃtO擾
	virtual void SetColors( VPalette * ) = 0;	// J[e[uݒ
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class VDG60 : public VDG6, public MC6847 {
protected:
	// J[R[h
	static const BYTE COL60_AN[];
	static const BYTE COL60_SG[];
	static const BYTE COL60_CG[][8];
	static const BYTE COL60_RG[][2];
	
	WORD GerVramAddr();							// VRAMAhX擾
	WORD GerAttrAddr();							// ATTRAhX擾
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void OutB0H( int, BYTE );
	
public:
	VDG60( VM6 *, const ID& );					// RXgN^
	virtual  ~VDG60();							// fXgN^
	
	void SetColors( VPalette * );				// J[e[uݒ
	
	// foCXID
	enum IDOut{ outB0H=0 };
	enum IDIn {};
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};



class VDG62 : public VDG6, public PCZ80_07 {
protected:
	// J[R[h
	static const BYTE COL62_AN[];
	static const BYTE COL62_SG[];
	static const BYTE COL62_CG[][8];
	static const BYTE COL62_RG[][2];
	static const BYTE COL62_AN2[];
	static const BYTE COL62_CG3[][16];
	static const BYTE COL62_CG4[][16];
	
	BYTE GetFont2( WORD );						// Font2f[^擾
	
	WORD GerVramAddr();							// VRAMAhX擾
	WORD GerAttrAddr();							// ATTRAhX擾
	
	void SetCss( BYTE );						// F̑gw
	void SetCrtControler( BYTE );				// CRTRg[[hݒ
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void OutB0H( int, BYTE );
	void OutC0H( int, BYTE );
	void OutC1H( int, BYTE );
	BYTE InC1H( int );
	
public:
	VDG62( VM6 *, const ID& );					// RXgN^
	virtual  ~VDG62();							// fXgN^
	
	void SetColors( VPalette * );				// J[e[uݒ
	
	// foCXID
	enum IDOut{ outB0H=0, outC0H, outC1H };
	enum IDIn {  inC1H=0 };
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


#endif	// VDG_H_INCLUDED
