#ifndef VSURFACE_H_INCLUDED
#define VSURFACE_H_INCLUDED


// T[tFX̎dl
//  F[x32bit̂
//  őTCY65536x65536

#define	AMASK32		0xff000000
#define	RMASK32		0x00ff0000
#define	GMASK32		0x0000ff00
#define	BMASK32		0x000000ff

#define	ASHIFT32	24
#define	RSHIFT32	16
#define	GSHIFT32	8
#define	BSHIFT32	0

struct COLOR24 {
	BYTE r;
	BYTE g;
	BYTE b;
	BYTE reserved;
};

// `̈\
struct VRect{
	int x, y;		// `̈W
	int w, h;		// `̈TCY
	
	VRect() : x(0), y(0), w(0), h(0) {}
};

struct VPalette{
	int ncols;
	COLOR24 *colors;
	
	VPalette() : ncols(0), colors(NULL) {}
};

#define COL2DW(c)	(DWORD)(((DWORD)c.reserved<<ASHIFT32)|((DWORD)c.r<<RSHIFT32)|((DWORD)c.g<<GSHIFT32)|((DWORD)c.b<<BSHIFT32))


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class VSurface {
protected:
	int w, h;					// ,
	int pitch;					// 1Cbyte
	void *pixels;				// sNZf[^ւ̃|C^
	
	VRect rect;					// `̈
	
public:
	VSurface();									// RXgN^
	virtual ~VSurface();						// fXgN^
	
	virtual bool InitSurface( int, int );		// (T[tFXTCYw)
	void SetRect( int, int, int, int );			// `̈ݒ
	VRect *GetRect();							// `̈擾
	
	int Width();								// 擾
	int Height();								// 擾
	int Pitch();								// 1Cbyte擾
	void *GetPixels();							// sNZf[^ւ̃|C^擾
	
	void PSet( int, int, DWORD );				// _`
	DWORD PGet( int, int );						// F擾
	void Fill( DWORD, VRect * = NULL );			// `̈hԂ
	void Blit( VRect *, VSurface *, VRect * );	// ]
};


#endif	// VSURFACE_H_INCLUDED
